<template>
  <div>
    <table class="table table-hover">
      <thead>
        <tr>
          <th scope="col" v-for="(header, idx) in headers" :key="idx">
            {{ header.title }}
            <i role="button" @click="sortItems(header.title, header.sortBy)">
              {{ iconSort }}
            </i>
          </th>
        </tr>
      </thead>
      <tbody>
        <tr
          v-for="(item, idx) in innerItems"
          :key="idx"
          @click="$emit('row-clicked', item)"
          :class="rowClass"
        >
          <slot name="row" :item="item" />
        </tr>
      </tbody>
    </table>
  </div>
</template>

<script setup lang="ts">
import { ref, Ref, computed, watch } from 'vue';

const ICON_DOWN = '↓';
const ICON_UP = '↑';

const iconSort = computed(() => {
  return sortDirection.value === 'asc' ? ICON_UP : ICON_DOWN;
});

const props = withDefaults(
  defineProps<{
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    items: Array<any>;
    search?: boolean;
    rowClass?: string;
    headers?: {
      title: string;
      sortBy?: string;
    }[];
    order?: 'asc' | 'desc';
  }>(),
  {
    order: 'asc',
  }
);

defineEmits<{
  (e: 'row-clicked', item: unknown): void;
  (e: 'update:items', item: unknown): void;
}>();

watch(
  () => props.items,
  () => {
    innerItems.value = props.items.slice();
    sortDirection.value = props.order;
  }
);

const colSorted = ref('');

const innerItems = ref(props.items);

const sortDirection: Ref<'asc' | 'desc'> = ref('asc');

const sortItems = (colTitle: string, sortBy?: string) => {
  colSorted.value = colTitle;
  if (!sortBy) {
    if (sortDirection.value === 'desc') {
      sortDirection.value = 'asc';
      innerItems.value = [...props.items].sort((a, b) => (b < a ? 1 : -1));
      return;
    }
    if (sortDirection.value === 'asc') {
      sortDirection.value = 'desc';
      innerItems.value = [...props.items].sort((a, b) => (a < b ? 1 : -1));
      return;
    }
  }

  if (sortBy && sortDirection.value === 'desc') {
    innerItems.value = props.items.slice().sort((a, b) => {
      sortDirection.value = 'asc';
      if (typeof a === 'object' && typeof b === 'object') {
        return a[sortBy] > b[sortBy] ? 1 : -1;
      }
      return 0;
    });
    return;
  }
  if (sortBy && sortDirection.value === 'asc') {
    innerItems.value = props.items.slice().sort((a, b) => {
      sortDirection.value = 'desc';
      if (typeof a === 'object' && typeof b === 'object') {
        return a[sortBy] < b[sortBy] ? 1 : -1;
      }
      return 0;
    });
  }
};
</script>

<style>
.table th,
.table td {
  font-size: 0.75rem;
  padding: 1.25rem 1.5rem;
}
</style>
